//+------------------------------------------------------------------+ 
//| T3 SATL ATR Channel arrows alerts mtf.mq4 
//| not for sale, auction, rent, nor lease
//| https://forex-station.com/viewtopic.php?p=1295401436#p1295401436
//| T3 SATL = Slow Adaptive Trend Line smoothed by T3 algorithm
/*
The ATR is an excellent tool for measuring volatility because it tells us 
the average trading range of the market for X amount of time, 
where X is whatever you want it to be.
So if you set ATR to 20 on a daily chart, it would show you the average trading range for the past 20 days.
Use ATR to measure price volatility.
When ATR is falling, it is an indication that volatility is decreasing.
When ATR is rising, it is an indication that volatility has been on the rise.
*/
//------------------------------------------------------------------
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 14
#property indicator_color1  clrNONE // SetIndexBuffer(0,T3SATLhuu); SetIndexStyle(0, DRAW_LINE);
#property indicator_width1  1
#property indicator_color2  clrNONE // SetIndexBuffer(1,T3SATLhud); SetIndexStyle(1, DRAW_LINE);
#property indicator_color3  clrNONE // SetIndexBuffer(2,T3SATLhdd); SetIndexStyle(2, DRAW_LINE);
#property indicator_width3  1
#property indicator_color4  clrNONE // SetIndexBuffer(3,T3SATLhdu); SetIndexStyle(3, DRAW_LINE);
#property indicator_color5  clrLime // uptrend line; SetIndexBuffer(4,T3SATL);
#property indicator_width5  5
#property indicator_color6  clrRed // downtrend line; SetIndexBuffer(5,T3SATLdowntrendLine); // uptrend line
#property indicator_width6  5
#property indicator_color7  clrNONE //SetIndexBuffer(6,TemporaryBuffer); // temp; don't need color
#property indicator_width7  1
 
#property indicator_color8  clrNONE //   SetIndexBuffer(7,prices); don't need color
#property indicator_color9  clrNONE //   SetIndexBuffer(8,slope); don't need color
#property indicator_color10  clrNONE //   SetIndexBuffer(9,count); don't need color

#property indicator_color11  clrDarkGray // main upper ATR channel
#property indicator_type11   DRAW_LINE
#property indicator_style11  STYLE_DOT

#property indicator_color12  clrDarkGray // main lower ATR channel
#property indicator_type12   DRAW_LINE
#property indicator_style12  STYLE_DOT

#property indicator_color13  clrDarkGray // outer upper ATR channel
#property indicator_type13   DRAW_LINE
#property indicator_style13  STYLE_SOLID

#property indicator_color14  clrDarkGray // outer lower ATR channel
#property indicator_type14   DRAW_LINE
#property indicator_style14  STYLE_SOLID

//33 enPrices
enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen,     // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2, // Heiken ashi trend biased (extreme) price
   pr_habclose,   // Heiken ashi (better formula) close
   pr_habopen,    // Heiken ashi (better formula) open
   pr_habhigh,    // Heiken ashi (better formula) high
   pr_hablow,     // Heiken ashi (better formula) low
   pr_habmedian,  // Heiken ashi (better formula) median
   pr_habtypical, // Heiken ashi (better formula) typical
   pr_habweighted,// Heiken ashi (better formula) weighted
   pr_habaverage, // Heiken ashi (better formula) average
   pr_habmedianb, // Heiken ashi (better formula) median body
   pr_habtbiased, // Heiken ashi (better formula) trend biased price
   pr_habtbiased2 // Heiken ashi (better formula) trend biased (extreme) price
};

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;   // Time frame
extern int             T3Period         = 8;
extern double          T3Hot            = 0.7;
extern bool            T3Original       = false;
extern enPrices        Price            = pr_close;         // Price to use for T3SATL calculation
extern string note1="-------------------------------------------------------";
extern bool            arrowsVisible    = true;             // Arrows visible?
extern bool            arrowsOnFirst    = true;            // Arrows shift?
extern string          arrowsIdentifier = "T3SATL ATR Arrows";   // Unique ID for arrows
extern double          arrowsUpperGap   = 1.0;              // Upper arrow gap
extern double          arrowsLowerGap   = 1.0;              // Lower arrow gap
extern color           arrowsUpColor    = clrDarkGreen;   // Up arrow color
extern color           arrowsDnColor    = clrCrimson; // Down arrow color
extern int             arrowsUpCode     = 221;              // Up arrow code
extern int             arrowsDnCode     = 222;              // Down arrow code
extern string note2="-------------------------------------------------------";
extern bool            alertsOn         = false;            // Turn alerts on?
extern bool            alertsOnCurrent  = false;            // Alerts on still opened bar?
extern bool            alertsMessage    = false;             // Alerts should display message?
extern bool            alertsSound      = false;            // Alerts should play a sound?
extern bool            alertsNotify     = false;            // Alerts should send a notification?
extern bool            alertsEmail      = false;            // Alerts should send an email?
extern string          soundFile        = "alert2.wav";     // Sound file
extern bool            Interpolate      = true;             // Interpolate in multi time frame mode?
extern string note3="-----ATR-----------------------------------------------";
extern int             ATRPeriod        = 14;
extern int             ATRshift         = 0;
extern double          ATRMultiplier1   = 1.5;
extern double          ATRMultiplier2   = 2.0;
extern string note4="-------------------------------------------------------";

double T3SATLhuu[],T3SATLhud[],T3SATLhdd[],T3SATLhdu[],T3SATL[],T3SATLdowntrendLine[],TemporaryBuffer[],prices[],slope[],count[];
double T3SATLshortStopLoss[], T3SATLlongStopLoss[], T3SATLupperChannel2[], T3SATLlowerChannel2[];
string indicatorFileName;

#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,T3Period,T3Hot,T3Original,Price,note1,arrowsVisible,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,note2,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,Interpolate,note3,ATRPeriod, ATRshift, ATRMultiplier1, ATRMultiplier2,note4, _buff,_ind)

//+------------------------------------------------------------------+
int OnInit()
{ 
   IndicatorBuffers(14);
   SetIndexBuffer(0,T3SATLhuu); SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(1,T3SATLhud); SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(2,T3SATLhdd); SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(3,T3SATLhdu); SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(4,T3SATL); // uptrend line
   SetIndexBuffer(5,T3SATLdowntrendLine); // downtrend line
   SetIndexBuffer(6,TemporaryBuffer); 
   SetIndexBuffer(7,prices); 
   SetIndexBuffer(8,slope); 
   SetIndexBuffer(9,count);

   SetIndexBuffer(10,T3SATLshortStopLoss, INDICATOR_DATA); 
   SetIndexLabel (10,"Inner Upper channel");
   SetIndexBuffer(11,T3SATLlongStopLoss,  INDICATOR_DATA); 
   SetIndexLabel (11,"Inner Lower channel");
   SetIndexBuffer(12,T3SATLupperChannel2, INDICATOR_DATA); 
   SetIndexLabel (12,"Outer Upper channel "+DoubleToString(ATRMultiplier2)+"x");
   SetIndexBuffer(13,T3SATLlowerChannel2, INDICATOR_DATA); 
   SetIndexLabel (13,"Outer Lower channel "+DoubleToString(ATRMultiplier2)+"x");
   
   indicatorFileName = WindowExpertName();
   TimeFrame         = fmax(TimeFrame,_Period);
    
    IndicatorShortName(timeFrameToString(TimeFrame)+" T3SATL-Slow Adaptive");
return (0);
}
int deinit()
{
   string lookFor       = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| T3SATL                                                             |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
   static double ATRrange1, ATRrange2 = 0;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(14,0)*TimeFrame/_Period)); 
               if (slope[limit]==-1) CleanPoint(limit,T3SATLdowntrendLine,TemporaryBuffer);
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
/*
   SetIndexBuffer(10,T3SATLshortStopLoss, INDICATOR_DATA); 
   SetIndexBuffer(11,T3SATLlongStopLoss,  INDICATOR_DATA); 
   SetIndexBuffer(12,T3SATLupperChannel2, INDICATOR_DATA); 
   SetIndexBuffer(13,T3SATLlowerChannel2, INDICATOR_DATA); 

*/
                     int y                  = iBarShift(NULL,TimeFrame,Time[i]);
                     T3SATL [i]             = _mtfCall(4,y); //   SetIndexBuffer(4,T3SATL);
                     T3SATLhuu[i]           = EMPTY_VALUE;
                     T3SATLhud[i]           = EMPTY_VALUE;
                     T3SATLhdd[i]           = EMPTY_VALUE;
                     T3SATLhdu[i]           = EMPTY_VALUE;
                     T3SATLdowntrendLine[i] = EMPTY_VALUE;
                     TemporaryBuffer[i]     = EMPTY_VALUE;
                     prices[i]              = EMPTY_VALUE;
                     count[i]               = EMPTY_VALUE;
                     slope[i]               = _mtfCall(8,y); //    SetIndexBuffer(8,slope); 
                     T3SATLshortStopLoss[i] = _mtfCall(10,y);
                     T3SATLlongStopLoss[i]  = _mtfCall(11,y);
                     T3SATLupperChannel2[i] = _mtfCall(12,y);
                     T3SATLlowerChannel2[i] = _mtfCall(13,y);
                     
                      if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                      #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                      int n,k; datetime time = iTime(NULL,TimeFrame,y);
                         for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                         for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) _interpolate(T3SATL);                                             
            }
            for(i=limit; i>=0; i--)
            {
               if (T3SATL[i]>0)
               if (slope[i]==1)
                     T3SATLhuu[i] = T3SATL[i];
               else  T3SATLhud[i] = T3SATL[i];
               if (T3SATL[i]<0)
               if (slope[i]==1)
                     T3SATLhdu[i] = T3SATL[i];
               else  T3SATLhdd[i] = T3SATL[i];
               if (slope[i]==-1) PlotPoint(i,T3SATLdowntrendLine,TemporaryBuffer,T3SATL);  
            }
   return(0);
   }
  
   if (slope[limit]==-1) CleanPoint(limit,T3SATLdowntrendLine,TemporaryBuffer);
   for (i=limit; i >= 0; i--)
   {
     if (i<Bars-1)
     {
       prices[i] = getPrice(Price,Open,Close,High,Low,i,Bars);
       double oldSATL =
            0.0982862174*prices[i+0] 
            +0.0975682269*prices[i+1] 
            +0.0961401078*prices[i+2] 
            +0.0940230544*prices[i+3] 
            +0.0912437090*prices[i+4] 
            +0.0878391006*prices[i+5] 
            +0.0838544303*prices[i+6] 
            +0.0793406350*prices[i+7] 
            +0.0743569346*prices[i+8] 
            +0.0689666682*prices[i+9] 
            +0.0632381578*prices[i+10] 
            +0.0572428925*prices[i+11] 
            +0.0510534242*prices[i+12] 
            +0.0447468229*prices[i+13] 
            +0.0383959950*prices[i+14] 
            +0.0320735368*prices[i+15] 
            +0.0258537721*prices[i+16] 
            +0.0198005183*prices[i+17] 
            +0.0139807863*prices[i+18] 
            +0.0084512448*prices[i+19] 
            +0.0032639979*prices[i+20] 
            -0.0015350359*prices[i+21] 
            -0.0059060082*prices[i+22] 
            -0.0098190256*prices[i+23] 
            -0.0132507215*prices[i+24] 
            -0.0161875265*prices[i+25] 
            -0.0186164872*prices[i+26] 
            -0.0205446727*prices[i+27] 
            -0.0219739146*prices[i+28] 
            -0.0229204861*prices[i+29] 
            -0.0234080863*prices[i+30] 
            -0.0234566315*prices[i+31] 
            -0.0231017777*prices[i+32] 
            -0.0223796900*prices[i+33] 
            -0.0213300463*prices[i+34] 
            -0.0199924534*prices[i+35] 
            -0.0184126992*prices[i+36] 
            -0.0166377699*prices[i+37] 
            -0.0147139428*prices[i+38] 
            -0.0126796776*prices[i+39] 
            -0.0105938331*prices[i+40] 
            -0.0084736770*prices[i+41] 
            -0.0063841850*prices[i+42] 
            -0.0043466731*prices[i+43] 
            -0.0023956944*prices[i+44] 
            -0.0005535180*prices[i+45] 
            +0.0011421469*prices[i+46] 
            +0.0026845693*prices[i+47] 
            +0.0040471369*prices[i+48] 
            +0.0052380201*prices[i+49] 
            +0.0062194591*prices[i+50] 
            +0.0070340085*prices[i+51] 
            +0.0076266453*prices[i+52] 
            +0.0080376628*prices[i+53] 
            +0.0083037666*prices[i+54] 
            +0.0083694798*prices[i+55] 
            +0.0082901022*prices[i+56] 
            +0.0080741359*prices[i+57] 
            +0.0077543820*prices[i+58] 
            +0.0073260526*prices[i+59] 
            +0.0068163569*prices[i+60] 
            +0.0062325477*prices[i+61] 
            +0.0056078229*prices[i+62] 
            +0.0049516078*prices[i+63] 
            +0.0161380976*prices[i+64]; 
                   
            T3SATL[i]   = iT3(oldSATL,T3Period,T3Hot,T3Original,i);

            ATRrange1 = iATR(NULL,TimeFrame,ATRPeriod,i+ATRshift);
            if(ATRrange1 == 0) ATRrange1 = 1;
            T3SATLshortStopLoss[i]    = T3SATL[i]+ATRrange1*ATRMultiplier1;      
            T3SATLlongStopLoss[i]    = T3SATL[i]-ATRrange1*ATRMultiplier1;    

            ATRrange2 = iATR(NULL,TimeFrame,ATRPeriod,i+ATRshift);
            if(ATRrange2 == 0) ATRrange2 = 1;          
            T3SATLupperChannel2[i]    = T3SATL[i]+ATRrange2*ATRMultiplier2;      
            T3SATLlowerChannel2[i]    = T3SATL[i]-ATRrange2*ATRMultiplier2;   
            
            T3SATLhuu[i] = EMPTY_VALUE;
       T3SATLhud[i] = EMPTY_VALUE;
       T3SATLhdd[i] = EMPTY_VALUE;
       T3SATLhdu[i] = EMPTY_VALUE;
       T3SATLdowntrendLine[i] = EMPTY_VALUE;
       TemporaryBuffer[i] = EMPTY_VALUE;
       slope[i] = (i<Bars-1) ? (T3SATL[i]>T3SATL[i+1]) ? 1 : (T3SATL[i]<T3SATL[i+1]) ? -1 : slope[i+1] : 0;            
       if (T3SATL[i]>0)
       if (slope[i]==1)
             T3SATLhuu[i] = T3SATL[i];
       else  T3SATLhud[i] = T3SATL[i];
       if (T3SATL[i]<0)
       if (slope[i]==1)
             T3SATLhdu[i] = T3SATL[i];
       else  T3SATLhdd[i] = T3SATL[i];
       if (slope[i]==-1) PlotPoint(i,T3SATLdowntrendLine,TemporaryBuffer,T3SATL);
        
       //
       //
       //
       //
       //
       
       if (arrowsVisible)
       {
          string lookFor = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);            
             if (i<Bars-1 && slope[i] != slope[i+1])
             {
                if (slope[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                if (slope[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
             } // if (i<Bars-1 && slope[i] != slope[i+1])
        } // if (arrowsVisible)
     }
   }
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] == 1) doAlert(" sloping up");
         if (slope[whichBar] ==-1) doAlert(" sloping down");       
      }         
   }   
return(0);
}
//+------------------------------------------------------------------
double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

double iT3(double price, double period, double hot, bool original, int i, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   int buffer = forInstance*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }
   
   return(workT3Coeffs[forInstance][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[r][2+buffer]);
}
//+------------------------------------------------------------------
#define _prHABF(_prtype) (_prtype>=pr_habclose && _prtype<=pr_habtbiased2)
#define _priceInstances     1
#define _priceInstancesSize 4
double workHa[][_priceInstances*_priceInstancesSize];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int bars, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=_priceInstancesSize; int r = bars-i-1;
         
         double haOpen  = (r>0) ? (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0 : (open[i]+close[i])/2;;
         double haClose = (open[i]+high[i]+low[i]+close[i]) / 4.0;
         if (_prHABF(tprice))
               if (high[i]!=low[i])
                     haClose = (open[i]+close[i])/2.0+(((close[i]-open[i])/(high[i]-low[i]))*MathAbs((close[i]-open[i])/2.0));
               else  haClose = (open[i]+close[i])/2.0; 
         double haHigh  = fmax(high[i], fmax(haOpen,haClose));
         double haLow   = fmin(low[i] , fmin(haOpen,haClose));
         
         if(haOpen<haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else               { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                              workHa[r][instanceNo+2] = haOpen;
                              workHa[r][instanceNo+3] = haClose;
         
         switch (tprice)
         {
            case pr_haclose:
            case pr_habclose:    return(haClose);
            case pr_haopen:   
            case pr_habopen:     return(haOpen);
            case pr_hahigh: 
            case pr_habhigh:     return(haHigh);
            case pr_halow:    
            case pr_hablow:      return(haLow);
            case pr_hamedian:
            case pr_habmedian:   return((haHigh+haLow)/2.0);
            case pr_hamedianb:
            case pr_habmedianb:  return((haOpen+haClose)/2.0);
            case pr_hatypical:
            case pr_habtypical:  return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:
            case pr_habweighted: return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:  
            case pr_habaverage:  return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
            case pr_habtbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
            case pr_habtbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}
//-------------------------------------------------------------------
void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}
//------------------------------------------------------------------
void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," T3SATL ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" T3SATL ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
//-------------------------------------------------------------------
void drawArrow(int i,color theColor,int theCode,bool up)
{

   string name = timeFrameToString(TimeFrame)+" "+arrowsIdentifier+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i);   

      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}
//-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//-------------------------------------------------------------------


  
